#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Mar 28 12:30:22 2019

@author: havard
"""

#Import Packages
import sqlite3 as sql
from sqlite3 import Error
import time
import datetime
import calendar
import numpy as np
import matplotlib.pyplot as plt
import pandas as pd
import readCSV as readCSV
import db as db

#Taking time
tic = time.time()

#Specifying path from where to read
#PATH OF THE ORIGINAL DATABASE

#path = '/Volumes/Transcend/PrelimContainer.db'

path = '/Users/havard/Desktop/Master/origianlDB/haavardDBnew.db'


#TABLE THAT SHOULD BE EXTRACTED FROM THE ORIGINAL DATABSE
tables = ['messagetype1','messagetype2','messagetype3','messagetype5']


#PATH AND NAME FOR THE NEW DATABASE
#newDbPathAndName = '/Users/havard/Desktop/Master/finalDB/container.db'
#newDbPathAndName = '/Users/havard/Desktop/Master/finalDB/bulk.db'
newDbPathAndName = '/Users/havard/Desktop/Master/finalDB/lng.db'
table = 'messagetype5'

#Import Ship List from CSV file and create list with MMSI numbers
shipList = readCSV.importShips(3,2018)
shipList = shipList.MMSI.values

################################################
#          Exploration of the db               #
################################################
#ORIGINAL DATABASE

#Find first and last date, and count of messages for each msgType
exploreDatabase = 0
if exploreDatabase == 1:
    for tableNr in tables:
        print(tableNr)
        con = sql.connect(path)
        unixtime = con.execute("SELECT COUNT(unixtime), min(unixtime),\
                               max(unixtime) FROM %s" % (tableNr)).fetchall()
        print('\nNumber of messages: ', unixtime[0][0])
        print('First date: ', datetime.datetime.utcfromtimestamp(unixtime[0][1]))
        print('Last date: ', datetime.datetime.utcfromtimestamp(unixtime[0][2]))
        con.close
        
#Count Number in shiptype
shipTypeCount = 0
if shipTypeCount ==1:
    query = "SELECT count(distinct userid) as NumberOfShips, \
    cast(ship_type/10 as int)*10 AS shiptype FROM %s \
    group by shiptype order by count(*)" %(table)
    con = sql.connect(path)
    with con:
        ais_dataframe = pd.read_sql_query(query,con)
    con.close()
    print(ais_dataframe.tail(20))

#Count number of different ships
shipTypeCount1 = 0
if shipTypeCount1 ==1:
    query = "SELECT DISTINCT userid as UserID FROM %s" %(table)
    con = sql.connect(path)
    with con:
        ais_dataframe = pd.read_sql_query(query,con)
    con.close()
    print(len(ais_dataframe))


#FINAL DATABSES
#Count Messges
countMessages = 0
if countMessages == 1:
    con = sql.connect(newDbPathAndName)
    countdyn = con.execute("SELECT COUNT(*) FROM dyn").fetchone()
    countstat = con.execute("SELECT COUNT(*) FROM stat").fetchone()
    print('Number of dynamic: ', countdyn[0])
    print('Number of static: ', countstat[0])
    con.close

#Number of unique vessels
countUniqueShips = 0
if countUniqueShips ==1:
    query = "SELECT DISTINCT userid as UserID FROM %s" %('dyn')
    con = sql.connect(newDbPathAndName)
    with con:
        ais_dataframe = pd.read_sql_query(query,con)
    con.close()
    print(len(ais_dataframe))

   
#Message Frequency Per ship
messageCountShip = 0
if messageCountShip ==1:
    query = "SELECT userid, count(*) FROM %s GROUP BY userid ORDER BY count(*)" %('dyn')
    con = sql.connect(newDbPathAndName)
    with con:
        ais_dataframe = pd.read_sql_query(query,con)
    con.close()
    print(len(ais_dataframe))
    containerShipCount = ais_dataframe
    #bulkShipCount = ais_dataframe
    #lngShipCount = ais_dataframe

################################################
#          Creating New Database               #
################################################

#Create New Databse with Ships from ShipList
createNewDatabase = 0
if createNewDatabase == 1:
    #Initiate Database
    con = sql.connect(newDbPathAndName)  
    con.execute("CREATE TABLE IF NOT EXISTS ShipList(userid INT)")
    con.execute("CREATE TABLE IF NOT EXISTS dyn(unixtime INT,\
    cog INT,latitude INT, longitude INT, nav_status INT, sog INT, userid INT,\
    msgType INT)")
    con.execute("CREATE TABLE IF NOT EXISTS stat(unixtime INT,\
    dest string, draught INT, eta INT, name text, ship_type INT, userid INT,\
    imo INT,msgType INT)")
    
    #Insert Ship List into own table only if list is empty
    count = con.execute("SELECT COUNT(*) FROM ShipList").fetchone()[0]
    if count == 0:   
        for ship in shipList:
            con.execute("INSERT INTO ShipList(userid) VALUES(?)", (ship,))
    con.commit()
    con.close()
    
    #Connect the new database with the total
    con = sql.connect(path)
    query = "ATTACH '%s' AS new;" % newDbPathAndName
    con.execute(query)
    
    # Insert the ships from ship list into new databse
    if int(table[-1]) == 5:
        #Static message
        query = "INSERT INTO new.stat SELECT unixtime,destination,draught,eta_day,name,\
        shiptype,mmsi,imo_num,%s FROM %s WHERE (mmsi in (SELECT userid FROM\
        new.ShipList)) ORDER BY UNIXTIME ASC" %(int(table[-1]),table)
    else:
       #Dynamic message
       query = "INSERT INTO new.dyn SELECT unixtime,cog,latitude,\
       longitude,nav_status,sog,mmsi,%s FROM %s WHERE (mmsi in \
       (SELECT userid FROM new.ShipList)) ORDER BY UNIXTIME ASC" %(int(table[-1]),table)      
    con.execute(query)
    con.commit()
    con.close()
    
#Create Index on userid and unixtime
createIndex = 0
if createIndex ==1:
    con = sql.connect(newDbPathAndName)  
    query = "CREATE INDEX userid ON dyn(userid)"   
    con.execute(query)
    query = "CREATE INDEX unix ON dyn(unixtime)"   
    con.execute(query)
    query = "CREATE INDEX useridS ON stat(userid)"   
    con.execute(query)
    query = "CREATE INDEX unixS ON stat(unixtime)"   
    con.execute(query)
    con.commit()
    con.close()

################################################
#  Only For Generation of Preliminary Database #
################################################
createPrelimDatabase = 0

if createPrelimDatabase == 1:
    path = '/Volumes/Transcend/AIS/S-AISGlobalOriginal.db'
    table = 'MessageType1'
    newDbPathAndName = "/Volumes/Transcend/PrelimContainer.db"
    shipList = readCSV.importShips(1,2015).MMSI.values
    
    sTime = calendar.timegm(time.strptime('01/1/2015','%d/%m/%Y'))
    eTime = calendar.timegm(time.strptime('01/01/2016','%d/%m/%Y'))
    
    
    #Create NewDatabse
    con = sql.connect(newDbPathAndName)  
    con.execute("CREATE TABLE IF NOT EXISTS ShipList(userid INT)")
    con.execute("CREATE TABLE IF NOT EXISTS dyn(unixtime INT,\
    cog INT,latitude INT, longitude INT, nav_status INT, sog INT, userid INT,\
    msgType INT)")
    con.execute("CREATE TABLE IF NOT EXISTS stat(unixtime INT,\
    dest string, draught INT, eta INT, name text, ship_type INT, userid INT,\
    imo INT,msgType INT)")
    
    #Insert Ship List into own table only if list is empty
    count = con.execute("SELECT COUNT(*) FROM ShipList").fetchone()[0]
    if count == 0:   
        for ship in shipList:
            con.execute("INSERT INTO ShipList(userid) VALUES(?)", (ship,))
    con.commit()
    con.close()
    
    #Connect the new database with the total
    con = sql.connect(path)
    query = "ATTACH '%s' AS new;" % newDbPathAndName
    con.execute(query)
    
    # Insert the ships from ship list into new databse
    if int(table[-1]) == 5:
        #Static message
        query = "INSERT INTO new.stat SELECT unixtime,dest,draught,eta,name,\
        ship_type,userid,imo,%s FROM %s WHERE (userid in (SELECT userid FROM \
        new.ShipList)) and unixtime >= %s and unixtime <= %s ORDER BY \
        UNIXTIME ASC" %(int(table[-1]),table,sTime,eTime)
    else:
       #Dynamic message
       query = "INSERT INTO new.dyn SELECT unixtime,cog,latitude,\
       longitude,nav_status,sog,userid,%s FROM %s WHERE \
       (userid in (SELECT userid FROM new.ShipList)) and \
       unixtime >= %s and unixtime <= %s  ORDER BY \
       UNIXTIME ASC" %(int(table[-1]),table,sTime,eTime)      
    con.execute(query)
    con.commit()
    con.close()

    
#FOR MEASSURING INDEX EFFICIENCY
    
#shipList = ais_dataframe[ais_dataframe.UserID > 23000000]
#shipList = shipList[shipList.UserID<799999999]
#shipList = shipList.head(3000).UserID.values
#shipList = shipList.astype(np.float64)

#takeTime = 0
#if takeTime == 1:
#    tic1 = time.time()
#    query = "SELECT distinct userid as UserID FROM %s" %(table)
#    con = sql.connect(newDbPathAndName)
#    with con:
#        ais_dataframe1 = pd.read_sql_query(query,con)
#    con.close()
#    print(ais_dataframe.size)
#    print("Count" , time.time()-tic1)


print('\nTotal time: ',time.time() - tic)