
#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Mar 13 10:18:34 2019

@author: havard
"""

import numpy as np
import pandas as pd
import math
import matplotlib.pyplot as plt
import sqlite3 as sql
import time
import datetime
import seaborn as sns
import matplotlib.pyplot as plt
import sklearn.cluster as cluster
from mpl_toolkits.basemap import Basemap


def clusterCentre(df):
    dfRes = pd.DataFrame(columns =['longitude','latitude','portNr'])
    ports = df['portNr'].unique()
    for port in ports:
        dfT = df[df['portNr']==port]
        dfRes.loc[port]=[dfT['longitude'].mean(),dfT['latitude'].mean(),dfT['portNr'].mean()]
    return dfRes

def clusterDBSCAN(x,y,r):
    '''
    run DBSCAN clustering on input(x,y,r)
    '''
    #Haversine to convert radius in km to radians
    km_pr_rad = 6371.0088
    eps = r/km_pr_rad
    points = list(zip(x,y))
    dbscan = cluster.DBSCAN(eps=eps,min_samples = 5, algorithm ='ball_tree',\
                         metric='haversine').fit(np.radians(points))
    labels = dbscan.labels_
    n_clusters_ = len(set(labels))-(1 if -1 in labels else 0)
    n_noise_ = list(labels).count(-1)
    
    
    print('Number of clusters:     ',n_clusters_)
    print('Number of noise poitns: ',n_noise_)
    print(labels)
    df = pd.DataFrame()
    df['longitude']= list(x)
    df['latitude'] = list(y)
    df['portNr']= list(labels)
    df = df[df['portNr'] != -1]
    df = clusterCentre(df)
    return df

    
def clusterKMEANS(x,y,n):
    '''
    K-means clustering (x,y,number of clusters)
    '''
    points = list(zip(x,y))
    k_means = cluster.KMeans(n_clusters = n).fit(points)
    cluster_centres = k_means.cluster_centers_
    labels = k_means.labels_
    clusterlon = cluster_centres[:,0]
    clusterlat = cluster_centres[:,1]
    
    
    return clusterlon,clusterlat,labels
    