#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Feb  4 11:29:23 2019

@author: havard
"""

#IMPORTING PACKAGES
import time
import datetime
import calendar
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
plt.rcParams.update({'font.size': 16})
import seaborn as sns

import ais as ais
import ais_Plotting as aisP
import db as db
import locationCheck as loc
import readCSV as csv
import machineLearning as ml

tic = time.time()

################################################
#               Data Management                # 
################################################
#DEFINING DATABASE PATH

#dbPath = '/Volumes/Transcend/AIS-Master/AISdatabase.db'
dbPathContainer = '/Users/havard/Desktop/Master/finalDB/container.db'
dbPathBulk = '/Users/havard/Desktop/Master/finalDB/bulk.db'
dbPathLng = '/Users/havard/Desktop/Master/finalDB/lng.db'

tableDyn = 'dyn'
tableStat = 'stat'


#SPESIFING RELEVANT DATA 
#Relevant Time Window [year,month,day]
fromTime = calendar.timegm(time.strptime('01/1/2018','%d/%m/%Y'))
toTime = calendar.timegm(time.strptime('01/01/2019','%d/%m/%Y'))




################################################
#                 DASHBOARD                    # 
################################################
DisplayDataBaseStatisics = 0

#Data Preparation
ExtractData = 0
ValidateData = 0

#Data Enrichment
FindPorts = 0
LableStatus = 0
LegNumbering = 0

#Operational Analytics
LableDraughtRatio = 0
LableArea = 0
OperationalAnalytics = 0
PresentResults = 1



SpeedAnalysis = 0
OperationalAnalysis = 0
LegAnalysis = 0
PlotData = 0
eastWestTrade = 0

lableStatus = 0
lableArea = 0
lableDraughtRatio = 0

Testing = 0

legLableHeadingAndArea =0


################################################
#               Function calls                 #
################################################

if DisplayDataBaseStatisics == 1:
    db.DatabaseInfo(dbPathContainer,table)
    db.DatabaseInfo(dbPathBulk,table)


# DATA PREPARATION
################################################
#Extract infomation form database into dataframes       
if ExtractData ==1:
    #Container Vessels
    vesselCount = db.msgCountPrVessel(dbPathContainer,tableDyn)
    vesselist = vesselCount.tail(200).userid.values
    dfContainer1 = db.Extract1(dbPathContainer,tableDyn,fromTime,toTime)
    dfContainer1 = dfContainer1[dfContainer1.userid.isin(vesselist)]
    dfContainer5 = db.Extract5(dbPathContainer,tableStat,fromTime,toTime)
    dfContainer5 = dfContainer5[dfContainer5.userid.isin(vesselist)]
    
    #Bulk Vessels
    vesselCount = db.msgCountPrVessel(dbPathBulk,tableDyn)
    vesselist = vesselCount.tail(200).userid.values
    dfBulk1 = db.Extract1(dbPathBulk,tableDyn,fromTime,toTime)
    dfBulk1 = dfBulk1[dfBulk1.userid.isin(vesselist)]
    dfBulk5 = db.Extract5(dbPathBulk,tableStat,fromTime,toTime)
    dfBulk5 = dfBulk5[dfBulk5.userid.isin(vesselist)]
    
    #Container Vessels
    vesselCount = db.msgCountPrVessel(dbPathLng,tableDyn)
    vesselist = vesselCount.tail(200).userid.values
    dfLng1 = db.Extract1(dbPathLng,tableDyn,fromTime,toTime)
    dfLng1 = dfLng1[dfLng1.userid.isin(vesselist)]
    dfLng5 = db.Extract5(dbPathLng,tableStat,fromTime,toTime)
    dfLng5 = dfLng5[dfLng5.userid.isin(vesselist)]


#Validate The Dataframes
if ValidateData ==1:
    #Test that IMO number not change
    imoTest = 1
    if imoTest ==1:
        #Remove messagees with changing imo number
        #Container Vessels
        changesContainer = ais.validateIMO(dfContainer5)
        dfContainer1 = dfContainer1[~dfContainer1.userid.isin(changesContainer)]
        #Bulk vessels
        changesBulk = ais.validateIMO(dfBulk5)
        dfBulk1 = dfBulk1[~dfBulk1.userid.isin(changesBulk)]
        #Lng vessels
        changesLng = ais.validateIMO(dfLng5)
        dfLng1 = dfLng1[~dfLng1.userid.isin(changesLng)]
    
    speedValidate = 1
    if speedValidate == 1:
        #Container Vessels
        dfContainer1 = dfContainer1[(dfContainer1.sog>=0)&(dfContainer1.sog<35)]
        #Bulk vessels
        dfBulk1  = dfBulk1[(dfBulk1.sog>=0)&(dfBulk1.sog<35)]
        #Lng vessels
        dfLng1 = dfLng1[(dfLng1.sog>=0)&(dfLng1.sog<35)]
    
    locValidation = 1
    if locValidation == 1:
        #Container Vessels
        dfContainer1 = dfContainer1[(dfContainer1.longitude>=-180)&\
                                    (dfContainer1.longitude<=180)]
        dfContainer1 = dfContainer1[(dfContainer1.latitude>=-90)&\
                                    (dfContainer1.latitude<=90)]
        #Bulk vessels 
        dfBulk1 = dfBulk1[(dfBulk1.longitude>=-180)&(dfBulk1.longitude<=180)]
        dfBulk1 = dfBulk1[(dfBulk1.latitude>=-90)&(dfBulk1.latitude<=90)]
        #LNG vessels
        dfLng1 = dfLng1[(dfLng1.longitude>=-180)&(dfLng1.longitude<=180)]
        dfLng1 = dfLng1[(dfLng1.latitude>=-90)&(dfLng1.latitude<=90)]

#Find Ports         
if FindPorts == 1:
    
    #Import Ports from Databse
    containerPorts = csv.importPorts(1)
    containerPorts.rename(columns = {'Longitude':'longitude',\
                                     'Latitude':'latitude'},inplace=True)
    bulkPorts = csv.importPorts(2)
    bulkPorts.rename(columns = {'Longitude':'longitude',\
                                'Latitude':'latitude'},inplace=True)
    lngPorts = csv.importPorts(3)
    lngPorts.rename(columns = {'Longitude':'longitude',\
                               'Latitude':'latitude'},inplace=True)
    #Visualice Ports
    #aisP.mapScatterLocal(containerPorts['Longitude'],containerPorts['Latitude'])
    
    #Find Ports using Clustring    
    clusterPorts =0
    if clusterPorts == 1:
        #Container Ports
        df1 = dfContainer1
        containerPortsCluster = ml.clusterDBSCAN(df1[(df1['sog']<3)&\
                        (df1['nav_status']==5)]['longitude'],df1[(df1['sog']<3)\
                        &(df1['nav_status']==5)]['latitude'],1)
        print('here')
        #Bulk Ports
        df1 = dfBulk1
        bulkPortsCluster = ml.clusterDBSCAN(df1[(df1['sog']<3)&\
                        (df1['nav_status']==5)]['longitude'],df1[(df1['sog']<3)\
                        &(df1['nav_status']==5)]['latitude'],1)
        #LNG Ports
        df1 = dfLng1
        lngPortsCluster = ml.clusterDBSCAN(df1[(df1['sog']<3)&\
                        (df1['nav_status']==5)]['longitude'],df1[(df1['sog']<3)\
                        &(df1['nav_status']==5)]['latitude'],1)
        
    #Validate clustered ports against datbasePorts
    validateClusteredPorts = 0
    if validateClusteredPorts == 1:
        #Calculate distance from point to closest dbPort    
        def closestPort(row,df):
            distances = []
            for port in df.itertuples():
                distances.append(ais.haversine(row.longitude,row.latitude,\
                                               port.longitude,port.latitude))
            dist = min(distances)
            return dist
        
        #Distance from clusterd port to closes port in portDatabase
        #For finding ports not identified in clustring
        containerPortsCluster['minDistToPort'] = \
        containerPortsCluster.apply(closestPort,args=(containerPorts,),axis=1)
        
        bulkPortsCluster['minDistToPort'] = \
        bulkPortsCluster.apply(closestPort,args=(bulkPorts,),axis=1)
        
        lngPortsCluster['minDistToPort'] = \
        lngPortsCluster.apply(closestPort,args=(lngPorts,),axis=1)
        
        
        #Accuracy of Port Locations, clusterd vs port list
        #Check points with sog = 0 and status == Moored
        #Container
        dfTContainer = dfContainer1[(dfContainer1.sog == 0) & \
                                    (dfContainer1.nav_status==5)].copy()
        dfTContainer['closestPortCluster'] = \
        dfTContainer.apply(closestPort,args=(containerPortsCluster,),axis=1)
        dfTContainer['closestPort'] = \
        dfTContainer.apply(closestPort,args=(containerPorts,),axis=1)
        
        #Bulk
        dfTBulk = dfBulk1[(dfBulk1.sog==0)&(dfBulk1.nav_status==5)].copy()
        dfTBulk['closestPortCluster'] = \
        dfTBulk.apply(closetsPort,args=(bulkPortsCluster,),axis =1)
        dfTBulk['closestPort']=dfTBulk.apply(closestPort,args=(bulkPorts,),axis=1)
        
        #Lng
        dfTLng = dfLng1[(dfLng1.sog==0)&(dfLng1.nav_status== 5)].copy()
        dfTLng['closesPortCluster'] = \
        dfTLng.apply(closestPort,args=(lngPortsCluster,),axis=1)
        dfTlng['closesPort'] = dfTLng.apply(closestPort,args=(lngPorts,),axis=1)

# DATA ENRICHMENT
################################################
#Fucntioncall for labelling of new operational statuses
if LableStatus ==1:
    lableStatuses = 0
    if lableStatuses == 1:
        #Container Vessels
        dfContainer1 = ais.lableStatus(dfContainer1,containerPorts)
        aisP.mapStatusScatterLocal(dfContainer1)
        #Bulk Vessels        
        dfBulk1 = ais.lableStatus(dfBulk1,bulkPorts)
        aisP.mapStatusScatterLocal(dfBulk1)
        #LNG vessels 
        dfLng1 = ais.lableStatus(dfLng1,lngPorts)
        aisP.mapStatusScatterLocal(dfLng1)
        
    #Visualice erroneous messages
    showErroneous=0
    if showErroneous == 1:
        #aisP.mapErroneousStatus(dfBulk1)
        aisP.mapErroneousStatus(dfContainer1)
    
    #Explore parameters
    exploreThreshold = 0
    if exploreThreshold == 1:
        def closestPort(row,df):
            distances = []
            for port in df.itertuples():
                distances.append(ais.haversine(row.longitude,row.latitude,\
                                               port.longitude,port.latitude))
            return min(distances) 
        #Validation of at anchor/waiting
        #Contaienr Vessels
        dfAContainer = dfContainer1[(dfContainer1.sog<3)&\
                                    (dfContainer1.nav_status==1)].copy()
        dfAContainer['distToPortAnch'] = dfAContainer.apply(closestPort,\
                    args=(containerPorts,),axis = 1)
        #Bulk vessels
        dfABulk = dfBulk1[(dfBulk1.sog<3)&(dfBulk1.nav_status==1)].copy()
        dfABulk['distToPortAnch'] = dfABulk.apply(closestPort,args=(bulkPorts,),axis = 1)
        #Lng vessels
        dfALng = dfLng1[(dfLng1.sog<3)&(dfLng1.nav_status==1)].copy()
        dfALng['distToPortAnch'] = dfALng.apply(closestPort,args=(lngPorts,),axis = 1)
        
    exploreChanges = 1
    if exploreChanges ==1:
        changesContainer = ais.statusChange(dfContainer1)
        changesBuk = ais.statusChange(dfBulk1)
        changesLng = ais.statusChange(dfLng1)
    
        
#Chategorise into distinct legs,port visits and time of waiting        
if LegNumbering == 1:
    dfContainer1 = ais.legNumbering(dfContainer1)
    dfBulk1 = ais.legNumbering(dfBulk1) 
    dfLng1 = ais.legNumbering(dfLng1)



# Operational Analytics
################################################

#Lable Draught Ratio in static message
if LableDraughtRatio == 1:
    #Container
    shipListContainer = csv.importShips(1,2018)
    shipListContainer = shipListContainer[shipListContainer.MMSI.isin(dfContainer5.userid.unique())]
    dfContainer5 = ais.lableStatDraughtRatio(dfContainer5,shipListContainer)
    #Bulk
    shipListBulk = csv.importShips(2,2018)
    shipListBulk = shipListBulk[shipListBulk.MMSI.isin(dfBulk5.userid.unique())]
    dfBulk5 = ais.lableStatDraughtRatio(dfBulk5,shipListBulk)
    #LNG
    shipListLng = csv.importShips(3,2018)
    shipListLng = shipListLng[shipListLng.MMSI.isin(dfLng5.userid.unique())]
    dfLng5 = ais.lableStatDraughtRatio(dfLng5,shipListLng)     
    
#Lable Area in Dynamic Messages
if LableArea == 1:    
    dfContainer1 = loc.lableArea(dfContainer1)
    dfBulk1 = loc.lableArea(dfBulk1)
    dfLng1 = loc.lableArea(dfLng1)
    
if OperationalAnalytics == 1:
    #Define Dataframe for Leg,wait, and port infomation
    sailContainer = pd.DataFrame()
    portContainer = pd.DataFrame()
    waitContainer = pd.DataFrame()
    
    sailBulk = pd.DataFrame()
    portBulk = pd.DataFrame()
    waitBulk = pd.DataFrame()
    
    sailLng = pd.DataFrame()
    portLng = pd.DataFrame()
    waitLng = pd.DataFrame()
        
    #Calculate sailing,port and wait time
    sailContainer, portContainer,waitContainer = ais.timeAnalytics(dfContainer1\
                                    ,sailContainer,portContainer,waitContainer)
    sailBulk, portBulk, waitBulk = ais.timeAnalytics(dfBulk1,sailBulk,\
                                            portBulk,waitBulk)
    sailLng, portLng, waitLng = ais.timeAnalytics(dfLng1,sailLng,\
                                                portLng,waitLng)

    #Leg Analytics
    sailContainer = ais.legAnalytics(dfContainer1,dfContainer5,sailContainer)
    sailBulk = ais.legAnalytics(dfBulk1,dfBulk5,sailBulk)
    sailLng = ais.legAnalytics(dfLng1,dfLng5,sailLng)
    
if PresentResults == 1:
    c1 = 'steelblue'
    c2 = 'darkorange'
    c3 = 'lightseagreen'
    c1l = 'lightblue'
    c2l = 'bisque'
    c3l = 'paleturqoise'
    
    plt.tick_params(labelsize=20)
    
    tradePattern = 0
    if tradePattern == 1:
        aisP.mapPlotDensity(dfContainer1)
        aisP.mapPlotDensity(dfBulk1)
        aisP.mapPlotDensity(dfLng1)
        aisP.mapPlotDensityType(dfContainer1,dfBulk1,dfLng1)
        
    #Explore Draught Ratio Diist, lng and bulk for determanating ballas vs laden
    draughtRatio = 0
    if draughtRatio ==1:
        #df1 = sailContainer[(sailContainer.maxMsgInt<12)&(sailContainer.area=='Pac')]
        #df1 = sailBulk[(sailBulk.maxMsgInt<12)]
        df1 = dfLng5
        plt.figure()
        bins = np.linspace(0.6, 1.1, 25)
        plt.hist(df1.dRatio, bins, alpha=1,color=c1,density=False)
        #plt.legend(loc='upper right')
        plt.xlabel('Draught Ratio')
        plt.ylabel('Messages')
        plt.show()
        
        df1 = dfBulk5
        plt.figure()
        bins = np.linspace(0.4, 1.1, 20)
        plt.hist(df1.dRatio, bins, alpha=1,color=c1,density=False)
       # plt.legend(loc='upper right')
        plt.xlabel('Draught Ratio')
        plt.ylabel('Messages')
        plt.show()
    
    #Bulk Laden vs Ballst Voyages
    bulkLadenVsBallast = 0
    if bulkLadenVsBallast ==1:
        d = [sailBulk[(sailBulk.maxMsgInt<6)&(sailBulk.voyageDist>200)&(sailBulk.avgSpeed>5)&(sailBulk.dRatio>0.8)].avgSpeed.values,\
              sailBulk[(sailBulk.maxMsgInt<6)&(sailBulk.voyageDist>200)&(sailBulk.avgSpeed>5)&(sailBulk.dRatio<0.7)].avgSpeed.values]
        plt.figure() 
        sns.boxplot(data = d,palette = [c1,c1],boxprops=dict(alpha=1))
        plt.xticks(plt.xticks()[0],['Laden','Ballast'])
        plt.ylabel('Average Speed')
        plt.show()

        print('Voyage Length: Bulk in Laden')
        print(sailBulk[(sailBulk.maxMsgInt<6)&(sailBulk.voyageDist>200)&(sailBulk.avgSpeed>5)&(sailBulk.dRatio>0.8)].voyageDist.describe())
        print('Voyage Length: Bulk in Ballast')
        print(sailBulk[(sailBulk.maxMsgInt<6)&(sailBulk.voyageDist>200)&(sailBulk.avgSpeed>5)&(sailBulk.dRatio<0.7)].voyageDist.describe())
    
    #LNG Laden vs Ballas Voyages
    lngLadenVsBallast = 0
    if lngLadenVsBallast ==1:
        d = [sailLng[(sailLng.maxMsgInt<6)&(sailLng.voyageDist>200)&(sailLng.avgSpeed>5)&(sailLng.dRatio>0.9)].avgSpeed.values,\
              sailLng[(sailLng.maxMsgInt<6)&(sailLng.voyageDist>200)&(sailLng.avgSpeed>5)&(sailLng.dRatio<0.8)].avgSpeed.values]
        plt.figure() 
        sns.boxplot(data = d,palette = [c1,c1],boxprops=dict(alpha=1))
        plt.xticks(plt.xticks()[0],['Laden','Ballast'])
        plt.ylabel('Average Speed')
        plt.show()

        print('Voyage Length: LNG in Laden')
        print(sailLng[(sailLng.maxMsgInt<6)&(sailLng.voyageDist>200)&(sailLng.avgSpeed>5)&(sailLng.dRatio>0.9)].voyageDist.describe())
        print('Voyage Length: LNG in Ballast')
        print(sailLng[(sailLng.maxMsgInt<6)&(sailLng.voyageDist>200)&(sailLng.avgSpeed>5)&(sailLng.dRatio<0.8)].voyageDist.describe())
    
    
    
    #Container Redistribution EeastWest Atltantic
    containerRedist = 1
    if containerRedist == 1:
        #ASIA-AMERICA
        #Speed      
        d = [sailContainer[(sailContainer.maxMsgInt<6)&(sailContainer.voyageDist>200)&(sailContainer.avgSpeed>5)&(sailContainer.dir<180)&(sailContainer.area=='Atl')].avgSpeed.values,\
        sailContainer[(sailContainer.maxMsgInt<6)&(sailContainer.voyageDist>200)&(sailContainer.avgSpeed>5)&(sailContainer.dir>=180)&(sailContainer.area=='Atl')].avgSpeed.values]
        plt.figure() 
        sns.boxplot(data = d,palette = [c1,c2],boxprops=dict(alpha=1))
        plt.xticks(plt.xticks()[0],['East Bound','West Bound'])
        plt.ylabel('Average Speed')
        plt.show()
        #Draught Raio
        d = [sailContainer[(sailContainer.maxMsgInt<6)&(sailContainer.voyageDist>200)&(sailContainer.avgSpeed>5)&(sailContainer.dir<180)&(sailContainer.area=='Atl')].dRatio.values,\
        sailContainer[(sailContainer.maxMsgInt<6)&(sailContainer.voyageDist>200)&(sailContainer.avgSpeed>5)&(sailContainer.dir>=180)&(sailContainer.area=='Atl')].dRatio.values]
        plt.figure() 
        sns.boxplot(data = d,palette = [c1,c2],boxprops=dict(alpha=1))
        plt.xticks(plt.xticks()[0],['East Bound','West Bound'])
        plt.ylabel('Draught Ratio')
        plt.show()
        
        #ASIA-Europ
        #Speed      
        d = [sailContainer[(sailContainer.maxMsgInt<6)&(sailContainer.voyageDist>200)&(sailContainer.avgSpeed>5)&(sailContainer.dir<180)&(sailContainer.area=='Ind')].avgSpeed.values,\
        sailContainer[(sailContainer.maxMsgInt<6)&(sailContainer.voyageDist>200)&(sailContainer.avgSpeed>5)&(sailContainer.dir>=180)&(sailContainer.area=='Ind')].avgSpeed.values]
        plt.figure() 
        sns.boxplot(data = d,palette = [c1,c2],boxprops=dict(alpha=1))
        plt.xticks(plt.xticks()[0],['East Bound','West Bound'])
        plt.ylabel('Average Speed')
        plt.show()
        #Draught Raio
        d = [sailContainer[(sailContainer.maxMsgInt<6)&(sailContainer.voyageDist>200)&(sailContainer.avgSpeed>5)&(sailContainer.dir<180)&(sailContainer.area=='Ind')].dRatio.values,\
        sailContainer[(sailContainer.maxMsgInt<6)&(sailContainer.voyageDist>200)&(sailContainer.avgSpeed>5)&(sailContainer.dir>=180)&(sailContainer.area=='Ind')].dRatio.values]
        plt.figure() 
        sns.boxplot(data = d,palette = [c1,c2],boxprops=dict(alpha=1))
        plt.xticks(plt.xticks()[0],['East Bound','West Bound'])
        plt.ylabel('Draught Ratio')
        plt.show()
        

toc = time.time()
print("Elapsed time total= ",toc-tic)